 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
//--------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "unicode.cpp"
#include "Copyright.h"
//--------------------------------------------------------------


unsigned short int unicode[256];


void usage() {
printf("%s",COPYRIGHT);
printf("Usage: Asc2Uni <lang> <text_1> [<text_2> <text_3> ...]\n%s",CR);
printf("     <lang> : language of the text file to be converted.\n%s",CR);
printf("              The following values are possible:\n%s",CR);
printf("              FRENCH\n%s",CR);
printf("              ENGLISH\n%s",CR);
printf("              GREEK\n%s",CR);
printf("              THAI\n%s",CR);
printf("              CZECH\n%s",CR);
printf("              GERMAN\n%s",CR);
printf("              SPANISH\n%s",CR);
printf("              PORTUGUESE\n%s",CR);
printf("              ITALIAN\n%s",CR);
printf("              NORWEGIAN\n%s",CR);
printf("              LATIN (default latin codepage)\n%s",CR);
printf("     <text_i> : text file to be converted\n\n%s",CR);
printf("Convert a WINDOWS ASCII text file into a UNICODE one with the extension '.uni'\n%s",CR);
}



void init_thai() {
unsigned short int i;
for (i=0;i<256;i++)
  unicode[i]=i;
unicode[0x80]=0x20ac;
unicode[0x85]=0x2026;
unicode[0x91]=0x2018;
unicode[0x92]=0x2019;
unicode[0x93]=0x201c;
unicode[0x94]=0x201d;
unicode[0x95]=0x2022;
unicode[0x96]=0x2013;
unicode[0x97]=0x2014;
for (i=0xa1;i<0xdb;i++)
  unicode[i]=(unsigned short int)(i+(0x0e00-0xa0));
for (i=0xdf;i<0xfc;i++)
  unicode[i]=(unsigned short int)(i+(0x0e00-0xa0));
}


void init_ansi() {
unsigned short int i;
for (i=0;i<256;i++)
  unicode[i]=i;
unicode[0x80]=0x20ac;
unicode[0x82]=0x201a;
unicode[0x83]=0x0192;
unicode[0x84]=0x201e;
unicode[0x85]=0x2026;
unicode[0x86]=0x2020;
unicode[0x87]=0x2021;
unicode[0x88]=0x02c6;
unicode[0x89]=0x2030;
unicode[0x8a]=0x0160;
unicode[0x8b]=0x2039;
unicode[0x8c]=0x0152;
unicode[0x8e]=0x017d;
unicode[0x91]=0x2018;
unicode[0x92]=0x2019;
unicode[0x93]=0x201c;
unicode[0x94]=0x201d;
unicode[0x95]=0x2022;
unicode[0x96]=0x2013;
unicode[0x97]=0x2014;
unicode[0x98]=0x02dc;
unicode[0x99]=0x2122;
unicode[0x9a]=0x0161;
unicode[0x9b]=0x203a;
unicode[0x9c]=0x0153;
unicode[0x9e]=0x017e;
unicode[0x9f]=0x0178;
}


void init_grec() {
unsigned short int i;
for (i=0;i<256;i++)
  unicode[i]=i;
unicode[0x80]=0x20ac;
unicode[0x82]=0x201a;
unicode[0x83]=0x0192;
unicode[0x84]=0x201e;
unicode[0x85]=0x2026;
unicode[0x86]=0x2020;
unicode[0x87]=0x2021;
unicode[0x89]=0x2030;
unicode[0x8b]=0x2039;
unicode[0x91]=0x2018;
unicode[0x92]=0x2019;
unicode[0x93]=0x201c;
unicode[0x94]=0x201d;
unicode[0x95]=0x2022;
unicode[0x96]=0x2013;
unicode[0x97]=0x2014;
unicode[0x99]=0x2122;
unicode[0x9b]=0x203a;
unicode[0xa1]=0x0385;
unicode[0xa2]=0x0386;
unicode[0xaf]=0x2015;
unicode[0xb4]=0x0384;
unicode[0xb8]=0x0388;
unicode[0xb9]=0x0389;
unicode[0xba]=0x038a;
unicode[0xbc]=0x038c;
unicode[0xbe]=0x038e;
unicode[0xbf]=0x038f;
for (i=0xc0;i<=0xd1;i++)
   unicode[i]=(unsigned short int)(i+(0x0390-0xc0));
for (i=0xd3;i<=0xfe;i++)
   unicode[i]=(unsigned short int)(i+(0x0390-0xc0));
}


void init_tcheque() {
unsigned short int i;
for (i=0;i<256;i++)
   unicode[i]=i;
unicode[0x80]=0x20ac;
unicode[0x82]=0x201a;
unicode[0x84]=0x201e;
unicode[0x85]=0x2026;
unicode[0x86]=0x2020;
unicode[0x87]=0x2021;
unicode[0x89]=0x2030;
unicode[0x8a]=0x0160;
unicode[0x8b]=0x2039;
unicode[0x8c]=0x015a;
unicode[0x8d]=0x0164;
unicode[0x8e]=0x017d;
unicode[0x8f]=0x0179;
unicode[0x91]=0x2018;
unicode[0x92]=0x2019;
unicode[0x93]=0x201c;
unicode[0x94]=0x201d;
unicode[0x95]=0x2022;
unicode[0x96]=0x2013;
unicode[0x97]=0x2014;
unicode[0x99]=0x2122;
unicode[0x9a]=0x0161;
unicode[0x9b]=0x203a;
unicode[0xa1]=0x02c7;
unicode[0xa2]=0x02d8;
unicode[0xa3]=0x0141;
unicode[0xa5]=0x0104;
unicode[0xaa]=0x015e;
unicode[0xaf]=0x017b;
unicode[0xb2]=0x02db;
unicode[0xb3]=0x0142;
unicode[0xb9]=0x0105;
unicode[0xba]=0x015f;
unicode[0xbc]=0x0178;
unicode[0xbd]=0x02dd;
unicode[0xbe]=0x013d;
unicode[0xbf]=0x017c;
unicode[0xc0]=0x0154;
unicode[0xc3]=0x0102;
unicode[0xc5]=0x0139;
unicode[0xc6]=0x0106;
unicode[0xc8]=0x010c;
unicode[0xca]=0x0118;
unicode[0xcc]=0x011a;
unicode[0xcf]=0x010e;
unicode[0xd0]=0x0110;
unicode[0xd1]=0x0143;
unicode[0xd2]=0x0147;
unicode[0xd5]=0x0150;
unicode[0xd8]=0x0158;
unicode[0xd9]=0x016e;
unicode[0xdb]=0x0170;
unicode[0xde]=0x0162;
unicode[0xe0]=0x0155;
unicode[0xe3]=0x0103;
unicode[0xe5]=0x013a;
unicode[0xe6]=0x0107;
unicode[0xe8]=0x010d;
unicode[0xea]=0x0119;
unicode[0xec]=0x011b;
unicode[0xef]=0x010f;
unicode[0xf0]=0x0111;
unicode[0xf1]=0x0144;
unicode[0xf2]=0x0148;
unicode[0xf5]=0x0151;
unicode[0xf8]=0x0159;
unicode[0xf9]=0x016f;
unicode[0xfb]=0x0171;
unicode[0xfe]=0x0163;
unicode[0xff]=0x02d9;
}


void convert(FILE *entree,FILE *sortie) {
int c;
unsigned short int n;
while ((c=fgetc(entree))!=EOF) {
   n=unicode[c];
   fwrite(&n,2,1,sortie);
}
}


int main(int argc, char **argv) {
FILE* entree;
FILE* sortie;
char res[1000];
int i;
if (argc<3) {
   usage();
   return 0;
}
if (!strcmp(argv[1],"FRENCH") ||
    !strcmp(argv[1],"ENGLISH") ||
    !strcmp(argv[1],"GERMAN") ||
    !strcmp(argv[1],"SPANISH") ||
    !strcmp(argv[1],"PORTUGUESE") ||
    !strcmp(argv[1],"ITALIAN") ||
    !strcmp(argv[1],"NORWEGIAN") ||
    !strcmp(argv[1],"LATIN"))
   init_ansi();
else if (!strcmp(argv[1],"THAI"))
     init_thai();
else if (!strcmp(argv[1],"GREEK"))
     init_grec();
else if (!strcmp(argv[1],"CZECH"))
     init_tcheque();
else {
     fprintf(stderr,"Invalid language parameter %s\n",argv[1]);
     return 1;
}

for (i=2;i<argc;i++) {
    strcpy(res,argv[i]);
    strcat(res,".uni");
    entree=fopen(argv[i],"rb");
    sortie=fopen(res,"wb");
    int problem=0;
    if (entree==NULL) {
       fprintf(stderr,"Cannot open %s\n",argv[i]);
       problem=1;
    }
    if (sortie==NULL) {
       fprintf(stderr,"Cannot write %s\n",res);
       problem=1;
       fclose(entree);
    }
    if (!problem) {
       fprintf(sortie,"%c%c",0xFF,0xFE);
       convert(entree,sortie);
       fclose(entree);
       fclose(sortie);
       printf("%s converted\n%s",argv[i],CR);
    }
}
return 0;
}



