 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.io.* ;

/*
 * This class describes the Check Dic window
 *
 */
public class CheckDicFrame extends JInternalFrame {
	
	public static CheckDicFrame frame;
	public JPanel panel=new JPanel();
	public JPanel leftPanel=new JPanel();
	public JPanel rightPanel=new JPanel();
	public JRadioButton DELAS=new JRadioButton("DELAS/DELAC");
	public JRadioButton DELAF=new JRadioButton("DELAF/DELACF");
	public JButton GO=new JButton("Check Dictionary");
	public JButton CANCEL=new JButton("Cancel");
	
	public CheckDicFrame() {
		super("Check Dictionary Format",false,true);
		constructPanel();
		setContentPane(panel);
		setBounds(100,100,200,100);
		pack();
		setResizable(false);
		setVisible(false);
		addInternalFrameListener(new InternalFrameListener() {
			public void internalFrameActivated(InternalFrameEvent e) {}
			public void internalFrameClosed(InternalFrameEvent e) {}
			public void internalFrameDeactivated(InternalFrameEvent e) {}
			public void internalFrameDeiconified(InternalFrameEvent e) {}
			public void internalFrameIconified(InternalFrameEvent e) {}
			public void internalFrameOpened(InternalFrameEvent e) {}
			public void internalFrameClosing(InternalFrameEvent e) {
				setVisible(false);
			}
		});
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	}


	public static void init() {
		frame=new CheckDicFrame();
	}
	
	
	public static CheckDicFrame getFrame() {
		return frame;
	}


	public static void showFrame() {
		frame.setVisible(true);
		frame.DELAF.setSelected(true);
		try { 
		    frame.setSelected(true);
		    frame.setIcon(false);
		} catch (java.beans.PropertyVetoException e2) {}
	}
	
	
	public void constructPanel() {
		panel.setOpaque(true);
		panel.setLayout(new BorderLayout());
		constructLeftPanel();
		constructRightPanel();
		panel.add(leftPanel,BorderLayout.WEST);
		panel.add(rightPanel,BorderLayout.CENTER);
	}


	public void constructLeftPanel() {
		JPanel tmp=new JPanel();
		leftPanel.setBorder(new EmptyBorder(0,0,0,0));
		tmp.setBorder(new TitledBorder("Dictionary Type:"));
		tmp.setLayout(new GridLayout(2,1));
		DELAS.setSelected(false);
		DELAF.setSelected(true);
		ButtonGroup bg=new ButtonGroup();
		bg.add(DELAS);
		bg.add(DELAF);
		tmp.add(DELAS);
		tmp.add(DELAF);
		leftPanel.add(tmp);
	}


	public void constructRightPanel() {
		rightPanel.setBorder(new EmptyBorder(12,5,5,7));
		rightPanel.setLayout(new GridLayout(2,1));
		CANCEL.addMouseListener(new CancelButtonListener());
		GO.addMouseListener(new GoButtonListener());
		rightPanel.add(GO);
		rightPanel.add(CANCEL);
	}



class GoButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				checkDELA();
			}
		});
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class CancelButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		setVisible(false);
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


	public void checkDELA() {
		setVisible(false);
		String command;
		command="\""+Config.getApplicationDir()+"CheckDic\" \"";
		command=command+Config.getCurrentDELA()+"\" ";
		if (DELAS.isSelected()) {command=command+"DELAS";}
		else {command=command+"DELAF";}
		String tmp=Config.getCurrentDELA();
		int point=tmp.lastIndexOf(File.separatorChar);
		tmp=tmp.substring(0,point+1);
		tmp=tmp+"CHECK_DIC.TXT";
		CheckResultFrame.close();
		new ProcessInfoFrame(command,true,new CheckDicDo(tmp));
	}


class CheckDicDo extends DoAbstract {
	String results;
	public CheckDicDo(String s) {
		results=s;
	}
	
	public void DO() {
		CheckResultFrame.load(results);
	}
}


}