 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.nio.charset.Charset;

/*
 * This class is used to display concordances
 *
 */
public class ConcordanceFrame extends JInternalFrame implements HyperlinkListener {
	JEditorPane text=new JEditorPane();
	JScrollPane scroll;
	JLabel nombre_matches=new JLabel("");
	
	
	public ConcordanceFrame() {
		super("",true,true,true,true);
		text.setEditable(false);
		scroll=new JScrollPane(text);
		JPanel middle=new JPanel();
		middle.setOpaque(true);
		middle.setLayout(new BorderLayout());
		middle.setBorder(BorderFactory.createLoweredBevelBorder());
		middle.add(scroll,BorderLayout.CENTER);
		JPanel top=new JPanel();
		top.setOpaque(true);
		top.setLayout(new BorderLayout());
		top.add(middle,BorderLayout.CENTER);
		top.setBorder(new EmptyBorder(2,2,2,2));
		JPanel up=new JPanel();
		up.setOpaque(true);
		up.setLayout(new BorderLayout());
		up.setBorder(new EmptyBorder(2,2,2,2));
		up.add(nombre_matches,BorderLayout.CENTER);
		top.add(up,BorderLayout.NORTH);
		setContentPane(top);
		pack();
		setBounds(150,50,850,550);
		setVisible(false);
		addInternalFrameListener(new InternalFrameListener() {
			public void internalFrameActivated(InternalFrameEvent e) {}
			public void internalFrameClosed(InternalFrameEvent e) {}
			public void internalFrameDeactivated(InternalFrameEvent e) {}
			public void internalFrameDeiconified(InternalFrameEvent e) {}
			public void internalFrameIconified(InternalFrameEvent e) {}
			public void internalFrameOpened(InternalFrameEvent e) {}
			public void internalFrameClosing(InternalFrameEvent e) {
				setVisible(false);
				dispose();
			}
		});
		text.addHyperlinkListener(this);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	}
	
	

       	public static void load(String concor,String n_matches) {
		ConcordanceFrame frame=new ConcordanceFrame();
		UnitexFrame.desktop.add(frame,UnitexFrame.DOCLAYER);
	 	frame.setTitle("Concordance: "+concor);
	 	if (n_matches!=null) frame.nombre_matches.setText(n_matches);
		try { 
		    frame.setSelected(true);
		    frame.setIcon(false);
		} catch (java.beans.PropertyVetoException e2) {}
		try {
		     frame.text.setPage(new URL(concor));
		     frame.setVisible(true);
		} catch (IOException e) {e.printStackTrace();}
	}
	

       	public static void load(String concor) {
		load(concor,null);
	}
	
	
	public void close() {
	        setVisible(false);
		dispose();
		System.gc();
	}



	public void hyperlinkUpdate(HyperlinkEvent e) {
		if (e.getEventType()==HyperlinkEvent.EventType.ACTIVATED) {
  			StringTokenizer s=new StringTokenizer(e.getDescription());
  			int a=new Integer(s.nextToken()).intValue();
			int b=new Integer(s.nextToken()).intValue();
			int c=new Integer(s.nextToken()).intValue();
			if (!TextFrame.FILE_TOO_LARGE) {
				try {
					TextFrame.getFrame().text.setSelectionStart(a);
					TextFrame.getFrame().text.setSelectionEnd(b);
					TextFrame.getFrame().setSelected(true);
				} catch (Throwable t) {}
			}
			try {
				TextAutomatonFrame.loadSentenceFromConcordance(c);
			} catch (Throwable t) {}
		}
	}


}
