 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.io.* ;

/*
 * This class describes the build concordance window
 *
 */
public class ConcordanceParameterFrame extends JInternalFrame {
	
	public static ConcordanceParameterFrame frame;
	public JPanel panel=new JPanel();
	public JPanel upPanel=new JPanel();
	public JPanel downPanel=new JPanel();
	public SpecialNumericTextField leftChars=new SpecialNumericTextField("40");
	public SpecialNumericTextField rightChars=new SpecialNumericTextField("55");
	public JComboBox sortBox;
	public JButton buildConcordance=new JButton("Build concordance");
	public JTextField sntFile=new JTextField("");
	public JButton setSntFile=new JButton("Set File");
	public JButton GO=new JButton("GO");
	public String nombre_matches=null;
	
	
	public ConcordanceParameterFrame() {
		super("Display indexed sequences...",false,true);
		constructPanel();
		setContentPane(panel);
		pack();
		setResizable(false);
		setVisible(false);
		addInternalFrameListener(new InternalFrameListener() {
			public void internalFrameActivated(InternalFrameEvent e) {}
			public void internalFrameClosed(InternalFrameEvent e) {}
			public void internalFrameDeactivated(InternalFrameEvent e) {}
			public void internalFrameDeiconified(InternalFrameEvent e) {}
			public void internalFrameIconified(InternalFrameEvent e) {}
			public void internalFrameOpened(InternalFrameEvent e) {}
			public void internalFrameClosing(InternalFrameEvent e) {
				setVisible(false);
			}
		});
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	}


	public static void init() {
		frame=new ConcordanceParameterFrame();
	}
	
	
	public static ConcordanceParameterFrame getFrame() {
		return frame;
	}


	public static void showFrame() {
		frame.nombre_matches=null;
		frame.setVisible(true);
		try { 
		    frame.setSelected(true); 
		    frame.setIcon(false);
		} catch (java.beans.PropertyVetoException e2) {}
	}
	

	public static void showFrame(String n_matches) {
		showFrame();
		frame.nombre_matches=n_matches;
	}
	
	
	public void constructPanel() {
		panel.setOpaque(true);
		panel.setLayout(new BorderLayout());
		constructUpPanel();
		constructDownPanel();
		panel.add(upPanel,BorderLayout.NORTH);
		panel.add(downPanel,BorderLayout.CENTER);
	}


	public void constructUpPanel() {
		upPanel.setBorder(new TitledBorder("Modify text"));
		upPanel.setLayout(new GridLayout(2,1));
		JPanel a=new JPanel();
		a.setLayout(new BorderLayout());
		a.add(new JLabel(" Resulting file: "),BorderLayout.WEST);
		a.add(sntFile,BorderLayout.CENTER);
		JPanel b=new JPanel();
		b.setLayout(new GridLayout(1,2));
		setSntFile.addMouseListener(new SetSntFileButtonListener());
		b.add(setSntFile);
		GO.addMouseListener(new GoButtonListener());
		b.add(GO);
		upPanel.add(a);
		upPanel.add(b);
	}


	public void constructDownPanel() {
		downPanel.setBorder(new TitledBorder("Show Matching Sequences in Context:"));
		downPanel.setLayout(new BorderLayout());
		JPanel tmp=new JPanel();
		tmp.setLayout(new GridLayout(1,2));
		tmp.add(new JLabel(" Lengths of Contexts:"));
		tmp.add(new JLabel(" Sort According to:"));
		downPanel.add(tmp,BorderLayout.NORTH);
		JPanel tmp2=new JPanel();
		tmp2.setLayout(new GridLayout(1,2));
		JPanel tmp_left=new JPanel();
		tmp_left.setLayout(new BorderLayout());
		JPanel a=new JPanel();
		a.setLayout(new GridLayout(2,1));
		a.add(new JLabel(" Left Col: "));
		a.add(new JLabel(" Right Col: "));
		JPanel pp1=new JPanel();
		pp1.setLayout(new BorderLayout());
		leftChars.setPreferredSize(new Dimension(30,20));
		rightChars.setPreferredSize(new Dimension(30,20));
		pp1.add(leftChars,BorderLayout.WEST);
		pp1.add(new JLabel(" chars."),BorderLayout.CENTER);
		JPanel b=new JPanel();
		b.setLayout(new GridLayout(2,1));
		JPanel pp2=new JPanel();
		pp2.setLayout(new BorderLayout());
		pp2.add(rightChars,BorderLayout.WEST);
		pp2.add(new JLabel(" chars."),BorderLayout.CENTER);
		b.add(pp1);
		b.add(pp2);
		tmp_left.add(a,BorderLayout.WEST);
		tmp_left.add(b,BorderLayout.CENTER);
		tmp2.add(tmp_left);
		JPanel tmp_right=new JPanel();
		tmp_right.setLayout(new GridLayout(2,1));
		String[] items=new String[7];
		items[0]="Text Order";
		items[1]="Left, Center Col.";
		items[2]="Left, Right Col.";
		items[3]="Center, Left Col.";
		items[4]="Center, Right Col.";
		items[5]="Right, Left Col.";
		items[6]="Right, Center Col.";
		sortBox=new JComboBox(items);
		sortBox.setSelectedIndex(3);
		tmp_right.add(sortBox);
		buildConcordance.addMouseListener(new BuildConcordanceButtonListener());
		tmp_right.add(buildConcordance);
		tmp2.add(tmp_right);
		downPanel.add(tmp2,BorderLayout.CENTER);
	}


class SpecialNumericTextField extends JTextField {
	SpecialNumericTextField(String s) {
		super();
		setEditable(true);
		setText(s);
		setHorizontalAlignment(JTextField.RIGHT);
	}
	public Document createDefaultModel() {
		return new SpecialNumericTextDocument();
	}
}


class SpecialNumericTextDocument extends PlainDocument {
	public void insertString(int offs,String s,AttributeSet a) throws BadLocationException {
		int i;
		if (s==null) return;
		char c[]=s.toCharArray();
		for (i=0;i<c.length;i++) {
			if ((c[i]<'0' || c[i]>'9')) return;
		}
		super.insertString(offs,s,a);
	}
}



class SetSntFileButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		JFileChooser chooser=new JFileChooser();
		chooser.addChoosableFileFilter(new PersonalFileFilter("txt","Unicode Raw Texts"));
		chooser.setDialogType(JFileChooser.SAVE_DIALOG);
		chooser.setCurrentDirectory(new File(Config.getCurrentCorpusDir()));
		int returnVal=chooser.showOpenDialog(null);
		if (returnVal!=JFileChooser.APPROVE_OPTION) {
			// we return if the user has clicked on CANCEL
			return;
		}
		sntFile.setText(chooser.getSelectedFile().getAbsolutePath());
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class GoButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				frame.modifyText();
			}
		});
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class BuildConcordanceButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				frame.buildConcordance();
			}
		});
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


	public void modifyText() {
		if (sntFile.getText().equals("")) {
			JOptionPane.showMessageDialog(null,"You must specify a text file","Error",JOptionPane.ERROR_MESSAGE);
			return;
		}
		String[] command=new String[3];
		File f;
		command[0]=Config.getCurrentSntDir()+"concord.ind";
		f=new File(command[0]);
		if (!f.exists()) {
			JOptionPane.showMessageDialog(null,"Cannot find "+command[0],"Error",JOptionPane.ERROR_MESSAGE);
			return;
		}
		command[0]="\""+Config.getApplicationDir()+"Concord\" \"";
		command[0]=command[0]+Config.getCurrentSntDir()+"concord.ind\" ";
		command[0]=command[0]+"NULL 0 0 0 NULL \"";
		command[0]=command[0]+sntFile.getText()+"\" NULL";
		
		command[1]=sntFile.getText();
		int l=command[1].lastIndexOf(File.separatorChar);
		int l2=command[1].lastIndexOf('.');
		if (l2>l) l=l2;
		command[1]=command[1].substring(0,l);
		command[1]=command[1]+"_snt";
		f=new File(command[1]);
		if (!f.exists()) f.mkdir();
		ModifyTextDo DO=null;
		if (sntFile.getText().equalsIgnoreCase(Config.getCurrentSnt())) {
			// if the result file is the current text, we must close some things
			UnitexFrame.mainFrame.closeText();
			DO=new ModifyTextDo(sntFile.getText());
		}
		command[1]="\""+Config.getApplicationDir()+"Normalize\" \"";
		command[1]=command[1]+sntFile.getText()+"\"";
		
		command[2]="\""+Config.getApplicationDir()+"Tokenize\" \"";
		command[2]=command[2]+sntFile.getText()+"\"";
		command[2]=command[2]+" \""+Config.getAlphabet()+"\"";
		if (Config.getCurrentLanguage().equals("Thai") ||
		    Config.getCurrentLanguage().equals("Korean")) {
				command[2]=command[2]+" -char_by_char";
		}
		setVisible(false);
		new ProcessInfoFrame(command,true,DO);
	}


	public void buildConcordance() {
		if (leftChars.getText().equals("")) {
			JOptionPane.showMessageDialog(null,"You must specify the left context length","Error",JOptionPane.ERROR_MESSAGE);
			return;
		}
		if (rightChars.getText().equals("")) {
			JOptionPane.showMessageDialog(null,"You must specify the right context length","Error",JOptionPane.ERROR_MESSAGE);
			return;
		}
		String command;
		command=Config.getCurrentSntDir()+"concord.ind";
		File f=new File(command);
		if (!f.exists()) {
			JOptionPane.showMessageDialog(null,"Cannot find "+command,"Error",JOptionPane.ERROR_MESSAGE);
			return;
		}
		command="\""+Config.getApplicationDir()+"Concord\" \"";
		command=command+Config.getCurrentSntDir()+"concord.ind\" ";
		command=command+"\""+Preferences.getConcordanceFontName()+"\" ";
		command=command+String.valueOf(Preferences.getConcordanceFontSize())+" ";
		command=command+leftChars.getText()+" "+rightChars.getText()+" ";
		switch (sortBox.getSelectedIndex()) {
			case 0: command=command+"TO "; break;
			case 1: command=command+"LC "; break;
			case 2: command=command+"LR "; break;
			case 3: command=command+"CL "; break;
			case 4: command=command+"CR "; break;
			case 5: command=command+"RL "; break;
			case 6: command=command+"RC "; break;
		}
		command=command+"html ";
		command=command+"\""+Config.getUserCurrentLanguageDir()+"Alphabet_sort.txt\"";
		if (Config.getCurrentLanguage().equals("Thai") ||
		   	Config.getCurrentLanguage().equals("Korean")) {
			command=command+" -thai";
		}
		setVisible(false);
		new ProcessInfoFrame(command,true,new ConcordanceDo(Config.getCurrentSntDir()+"concord.html"));
	}


class ConcordanceDo extends DoAbstract {
	String pageHtml;

	public ConcordanceDo(String page) {
		pageHtml=page;
	}
	public void DO() {
		if (Preferences.pref.htmlViewer!=null && !Preferences.pref.htmlViewer.equals("")) {
			new Thread() {
				public void run() {
					String[] s=new String[2];
					s[0]=Preferences.pref.htmlViewer;
					s[1]=pageHtml;
					Console.add("\""+s[0]+"\" \""+s[1]+"\"");
					try {
						Runtime.getRuntime().exec(s);
					} catch(IOException e) {e.printStackTrace();}
				}
			}.start();
		}
		else {
			ConcordanceFrame.load("file:///"+pageHtml,nombre_matches);
		}
	}	
}


static class ModifyTextDo extends DoAbstract {
	String SNT;

	public ModifyTextDo(String s) {
		SNT=s;
	}
	public void DO() {
		Text.loadSnt(SNT);
	}	
}


}
