 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.nio.charset.Charset;
import java.nio.channels.*;

/*
 * This class is used to display DELA
 *
 */
public class DelaFrame extends JInternalFrame implements InternalFrameListener {
	MyTextArea text=new MyTextArea();
	JScrollPane scroll;
	public static DelaFrame frame;
	public static boolean FILE_TOO_LARGE=false;

	public DelaFrame() {
		super("",true,true,true,true);
		JPanel top=new JPanel();
		top.setOpaque(true);
		top.setLayout(new BorderLayout());
		top.setBorder(new EmptyBorder(2,2,2,2));
		scroll=new JScrollPane(text);
		scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		JPanel middle=new JPanel();
		middle.setOpaque(true);
		middle.setLayout(new BorderLayout());
		middle.setBorder(BorderFactory.createLoweredBevelBorder());
		middle.add(scroll,BorderLayout.CENTER);
		top.add(middle,BorderLayout.CENTER);
		setContentPane(top);
		pack();
		setBounds(100,100,600,600);
		setVisible(false);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addInternalFrameListener(this);
	}
	
	
	public static void init() {
		frame=new DelaFrame();
	}

	
	public static DelaFrame getFrame() {
		return frame;
	}

	
	
	public static void loadDela(String dela) {
		frame.text.setFont(Config.getCurrentTextFont());
		frame.text.setWrapStyleWord(true);
		frame.text.setLineWrap(true);
		frame.text.setEditable(false);
		File FILE=new File(dela);
		if (!FILE.exists() || FILE.length()<=2) {
			FILE_TOO_LARGE=true;
			frame.text.setDocument(new PlainDocument());
			frame.text.setText(Config.EMPTY_FILE_MESSAGE);
		}
		else if (FILE.length()<Config.MAX_FILE_SIZE) {	
			try {
				frame.text.load(FILE);
			} catch (java.io.IOException e) {FILE_TOO_LARGE=true; return;}
			FILE_TOO_LARGE=false;
		}
		else {
			FILE_TOO_LARGE=true;
			frame.text.setDocument(new PlainDocument());
			frame.text.setText(Config.FILE_TOO_LARGE_MESSAGE);
		}
		frame.setTitle(dela);
		frame.setVisible(true);
		try { 
		    frame.setIcon(false);
		    frame.setSelected(true); 
		} catch (java.beans.PropertyVetoException e2) {}
	}
	
	
	public static void closeDela() {
		frame.setVisible(false);
		frame.text.setDocument(new PlainDocument());
		System.gc();
	}
	
	
	public void internalFrameActivated(InternalFrameEvent e) {}
	public void internalFrameClosed(InternalFrameEvent e) {}
	public void internalFrameClosing(InternalFrameEvent e) {
		UnitexFrame.mainFrame.closeDELA();
	}
	public void internalFrameDeactivated(InternalFrameEvent e) {}
	public void internalFrameDeiconified(InternalFrameEvent e) {}
	public void internalFrameIconified(InternalFrameEvent e) {}
	public void internalFrameOpened(InternalFrameEvent e) {}

}