 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.text.TextAction.*;

/*
 * This class is used to create a clipboard content from a vector of selected boxes
 *
 */
public class MultipleSelection {
	
	public int n=0;
	
	public Vector elem;
	
	public MultipleSelection(Vector v) {
		int L=v.size();
		elem=new Vector();
		for (int i=0;i<L;i++) {
			// here we numerote the selected states
			GraphBox g=(GraphBox)v.get(i);
			g.numero=i;
			// and create the corresponding GraphBoxInfo
			GraphBoxInfo gbi=new GraphBoxInfo();
			gbi.X=g.X;
			gbi.Y=g.Y;
			gbi.contenu=g.contenu;
			gbi.tmp=new Vector();
			elem.add(gbi);
		}
		for (int i=0;i<L;i++) {
			// here we create relative transitions
			GraphBox g=(GraphBox)v.get(i);
			GraphBoxInfo gbi=(GraphBoxInfo)elem.get(i);
			Vector temp=g.transitions;
			int k=temp.size();
			for (int j=0;j<k;j++) {
				GraphBox dest=(GraphBox)temp.get(j);
				if (dest.numero!=-1) {
					// we only consider the transitions that lead to box into the selection
					gbi.tmp.add(new Integer(dest.numero));
				}
			}
		}
		for (int i=0;i<L;i++) {
			// finally, we put the numero value back to -1
			GraphBox g=(GraphBox)v.get(i);
			g.numero=-1;
		}
	}


	//
	// this constructor is used to construct a multiple selection from FstBoxes
	//
	public MultipleSelection(Vector v,boolean fstBoxes) {
		int L=v.size();
		elem=new Vector();
		for (int i=0;i<L;i++) {
			// here we numerote the selected states
			FstGraphBox g=(FstGraphBox)v.get(i);
			g.numero=i;
			// and create the corresponding GraphBoxInfo
			GraphBoxInfo gbi=new GraphBoxInfo();
			gbi.X=g.X;
			gbi.Y=g.Y;
			gbi.contenu=g.contenu;
			gbi.tmp=new Vector();
			elem.add(gbi);
		}
		for (int i=0;i<L;i++) {
			// here we create relative transitions
			FstGraphBox g=(FstGraphBox)v.get(i);
			GraphBoxInfo gbi=(GraphBoxInfo)elem.get(i);
			Vector temp=g.transitions;
			int k=temp.size();
			for (int j=0;j<k;j++) {
				FstGraphBox dest=(FstGraphBox)temp.get(j);
				if (dest.numero!=-1) {
					// we only consider the transitions that lead to box into the selection
					gbi.tmp.add(new Integer(dest.numero));
				}
			}
		}
		for (int i=0;i<L;i++) {
			// finally, we put the numero value back to -1
			FstGraphBox g=(FstGraphBox)v.get(i);
			g.numero=-1;
		}
	}

}