 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

/*
 * This class is used to display stdout and stderr messages during shell command execution
 *
 */
public class ProcessInfoFrame extends JInternalFrame {
	public static Process p;
	JTextArea text_stdout=new JTextArea();
	JScrollPane scroll;
	JTextArea text_stderr=new JTextArea();
	JScrollPane errorScroll;
	JButton ok=new JButton("OK");
	JButton cancel=new JButton("Cancel");
	boolean close_on_finish;
	public ProcessInfoFrame infoFrame;
	String[] command=null;
	DoAbstract DO;
	

	public ProcessInfoFrame(String[] c,boolean close,DoAbstract myDo) {
		super("Working...",true,false,false);
		command=c;
		close_on_finish=close;
		DO=myDo;
		JPanel top=new JPanel();
		top.setOpaque(true);
		top.setLayout(new BorderLayout());
		scroll=new JScrollPane(text_stdout);
		errorScroll=new JScrollPane(text_stderr);
		JPanel middle=new JPanel();
		middle.setOpaque(true);
		middle.setLayout(new GridLayout(2,1));
		middle.setBorder(new EmptyBorder(2,2,2,2));
		JPanel tmp=new JPanel();
		tmp.setOpaque(true);
		tmp.setLayout(new BorderLayout());
		tmp.setBorder(BorderFactory.createLoweredBevelBorder());
		tmp.add(scroll,BorderLayout.CENTER);
		JPanel tmp2=new JPanel();
		tmp2.setOpaque(true);
		tmp2.setLayout(new BorderLayout());
		tmp2.setBorder(BorderFactory.createLoweredBevelBorder());
		tmp2.add(errorScroll,BorderLayout.CENTER);
		middle.add(tmp);
		middle.add(tmp2);
		top.add(middle,BorderLayout.CENTER);
		ok.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent e) {}
			public void mouseReleased(MouseEvent e) {}
			public void mouseMoved(MouseEvent e) {}
			public void mouseDragged(MouseEvent e) {}
			public void mouseEntered(MouseEvent e) {}
			public void mouseExited(MouseEvent e) {}
			public void mousePressed(MouseEvent e) {
				if (p!=null) {
				try {
					p.exitValue();
				} catch(IllegalThreadStateException ex) {return;}
				}
				setVisible(false);
				dispose();
			}
		});
		cancel.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent e) {}
			public void mouseReleased(MouseEvent e) {}
			public void mouseMoved(MouseEvent e) {}
			public void mouseDragged(MouseEvent e) {}
			public void mouseEntered(MouseEvent e) {}
			public void mouseExited(MouseEvent e) {}
			public void mousePressed(MouseEvent e) {
				if (p!=null) p.destroy();
				if (command!=null) {
					for (int i=0;i<command.length;i++)
						command[i]=null;
				}
				setVisible(false);
				dispose();
			}
		});
		JPanel buttons=new JPanel();
		buttons.setOpaque(true);
		buttons.setLayout(new GridLayout(1,2));
		buttons.add(ok);
		buttons.add(cancel);
		top.add(buttons,BorderLayout.SOUTH);
		setContentPane(top);
		pack();
		setBounds(100,100,600,400);
		UnitexFrame.desktop.add(this,UnitexFrame.DOCLAYER);
	 	setVisible(true);
		try {
			setSelected(true); 
			setIcon(false);
		} catch (java.beans.PropertyVetoException e) {}
		infoFrame=this;
		launchCommand();
	}
	
	
	public static String[] toStringArray(String s) {
		String t[]=new String[1];
		t[0]=s;
		return t;
	}
	
	public ProcessInfoFrame(String[] c,boolean close_on_finish) {
		this(c,close_on_finish,null);
	}

	
	public ProcessInfoFrame(String c,boolean close_on_finish) {
		this(toStringArray(c),close_on_finish,null);
	}


	public ProcessInfoFrame(String c,boolean close_on_finish,DoAbstract DO) {
		this(toStringArray(c),close_on_finish,DO);
	}


	int i;
	public void launchCommand() {
		if (command==null) return;
		new Thread() {
			public void run() {
				boolean problem=false;
				for (i=0;(!problem) && i<command.length;i++) {
					if (command[i]!=null) {
						Console.add(command[i]);
						try {
						    String[] comm=tokenizeCommandLine(command[i]);
							p=Runtime.getRuntime().exec(comm);
							new ProcessInfoThread(text_stdout,p.getInputStream(),false,infoFrame,scroll.getVerticalScrollBar()).start();
							new ProcessInfoThread(text_stderr,p.getErrorStream(),false,infoFrame,errorScroll.getVerticalScrollBar()).start();
							try {
								p.waitFor();
							} catch (java.lang.InterruptedException e) {problem=true;}
						} catch (java.io.IOException e) {
						    e.printStackTrace();
						    problem=true;
						}
						if (p==null || p.exitValue()!=0) {
							problem=true;
						}
					}
				}
				if (problem==true) {
					setTitle("ERROR");
				} else {
					setTitle("");
				}
				if (!problem && close_on_finish) {
					infoFrame.setVisible(false);
					infoFrame=null;
				}
				if (!problem && DO!=null) {
					DO.DO();
				}
			}
		}.start();
	}


		    public String[] tokenizeCommandLine(String line) {
			String[] tmp=new String[30];
			int pos=0;
			int L=line.length();
			int count=0;
			while (pos<L) {
			    while (pos<L && line.charAt(pos)==' ') pos++;
			    tmp[count]="";
			    if (pos<L && line.charAt(pos)=='"') {
				// we are in the case of a "jkjkj" string
				pos++;
				while (pos<L && line.charAt(pos)!='"') {
				    tmp[count]=tmp[count]+String.valueOf(line.charAt(pos));
				    pos++;
				}
			    }
			    else {
				while (pos<L && line.charAt(pos)!=' ') {
				    tmp[count]=tmp[count]+String.valueOf(line.charAt(pos));
				    pos++;
				}
			    }
			    count++;
			    pos++;
			}
			String[] res=new String[count];
			for (int i=0;i<count;i++) {
			    res[i]=tmp[i];
			}
			return res;
		    }

}
